// NetParmsDemo.java

import java.net.InetAddress;
import java.net.InterfaceAddress;
import java.net.NetworkInterface;
import java.net.SocketException;

import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

public class NetParmsDemo
{
   public static void main (String [] args) throws SocketException
   {
      Enumeration<NetworkInterface> nis;
      nis = NetworkInterface.getNetworkInterfaces ();

      while (nis.hasMoreElements ())
      {
         NetworkInterface ni = nis.nextElement ();

         System.out.println ("Network interface: " + ni.getName ());

         System.out.println ("  Display name: " + ni.getDisplayName ());

         System.out.println ("  Virtual interface: " + ni.isVirtual ());

         System.out.println ("  Maximum transmission unit: " + ni.getMTU ());

         System.out.println ("  Supports multicasting: " +
                             ni.supportsMulticast ());

         System.out.println ("  Point to point interface: " +
                             ni.isPointToPoint ());

         System.out.println ("  Loopback interface: " + ni.isLoopback ());

         System.out.println ("  Interface up and running: " + ni.isUp ());

         byte [] hardwareAddress = ni.getHardwareAddress ();
         if (hardwareAddress != null)
         {
             System.out.print ("  Hardware address = ");
             for (int i = 0; i < hardwareAddress.length; i++)
                  System.out.printf ("%02X%c", hardwareAddress [i],
                                     (i != hardwareAddress.length-1) ? '-' :
                                     '\0');
             System.out.println ();
         }

         List<InterfaceAddress> ias = ni.getInterfaceAddresses ();

         Iterator<InterfaceAddress> iias = ias.iterator ();
         while (iias.hasNext ())
         {
            InterfaceAddress ia = iias.next ();
            if (ia == null) // It is possible for getInterfaceAddresses() to
                break;      // return a list containing a single null element.

            System.out.println ("  Interface Address");
            System.out.println ("    Address: " + ia.getAddress ());
            System.out.println ("    Broadcast: " + ia.getBroadcast ());
            System.out.println ("    Prefix length: " +
                                ia.getNetworkPrefixLength ());
         }

         Enumeration<InetAddress> inas = ni.getInetAddresses ();
         while (inas.hasMoreElements ())
         {
            InetAddress ia = inas.nextElement ();

            System.out.println ("  Internet address = " + ia);
         }

         System.out.println ();
      }
   }
}
